<?php
include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-ipsec");



function toSubnet($addr,$netmask){
$ip=array();
foreach(explode(".",$addr) as $b){
	array_push($ip,pack('C',$b));
}

$nm=array();
foreach(explode(".",$netmask) as $b){
        array_push($nm,pack('C',$b));
} 

$n1 = unpack('Cchar',($nm[0] & $ip[0]));
$n2 = unpack('Cchar',($nm[1] & $ip[1]));
$n3 = unpack('Cchar',($ip[2] & $nm[2]));
$n4 = unpack('Cchar',($ip[3] & $nm[3]));
$network = $n1["char"].".".$n2["char"].".".$n3["char"].".".$n4["char"];
return $network;

}


// get objects
$system = $cceClient->getObject("System");
$eth0 = $cceClient->getObject("Network", array("device" => "eth0"));
$eth1 = $cceClient->getObject("Network", array("device" => "eth1", "enabled"=>1));

if($eth1 == null){
	$ipsecIp=$eth0["ipaddr"];
}else{
	$ipsecIp=$eth1["ipaddr"];
}

$backButton = $factory->getBackButton("/base/ipsec/tunnelList.php");

$page = $factory->getPage();

$block = $factory->getPagedBlock("ipsecInfo");
$block->setColumnWidths(array("40%","60%"));

$block->addFormField(
  $factory->getIpAddress("foo", $ipsecIp, "r"),
  $factory->getLabel("leftIpAddressField")
);

$block->addFormField(
  $factory->getNetAddress("foo2", toSubnet($eth0["ipaddr"], $eth0["netmask"]), "r"),
  $factory->getLabel("leftSubnetField")
); 

$block->addFormField(
  $factory->getTextField("foo3", $eth0["netmask"], "r"),
  $factory->getLabel("leftNetmaskField")
); 


$block->addFormField(
  $factory->getCompositeFormField(array($factory->getButton("javascript: top.code.Ipsec_LaunchKeyWindow(top)", "openKey"))),
  $factory->getLabel("leftRsaKeyField")
);


$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<?php print($block->toHtml()); ?>
<BR>
<?php print($backButton->toHtml()); ?>

<?php print($page->toFooterHtml()); ?>
