<?php

include("ServerScriptHelper.php");
 
$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$i18n = $serverScriptHelper->getI18n();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-ipsec");

$page = $factory->getPage();

$back = $factory->getBackButton("/base/ipsec/tunnelList.php");

$scrollList = $factory->getScrollList("profileList", array("pname", "comment",
"listAction"), array());
$scrollList->setAlignments(array("left", "left", "center"));
$scrollList->setColumnWidths(array("", "30%", "1%"));
$scrollList->addButton(
        $factory->getAddButton(
                "javascript: location='/base/ipsec/profileAdd.php';"
                . " top.code.flow_showNavigation(false)",
                "[[base-ipsec.addProfile_help]]"));

$profiles = $cceClient->find("IpsecProfile");

for($i=0; $i<count($profiles); $i++){
	$profile=$cceClient->get($profiles[$i]);

$modify=$factory->getModifyButton("javascript: location='/base/ipsec/profileMod.php?profileName=".urlencode($profile["name"])."'; top.code.flow_showNavigation(false)");

$remove=$factory->getRemoveButton("javascript: confirmRemove('".$profile["name"]."', '".urlencode($profile["name"])."')");

if($profile["name"] == "Qube3"){
	$modify->setDisabled(true);
	$remove->setDisabled(true);
}

	$scrollList->addEntry(array(
		$factory->getTextField("", $i18n->interpolate($profile["name"]), "r"),
		$factory->getTextField("", $i18n->interpolate($profile["comments"]), "r"),
		$factory->getCompositeFormField(array($modify, $remove))
	), "", false, $i);
}

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
 
<SCRIPT LANGUAGE="javascript">
function confirmRemove(displayName, sendName) {
  var message = "<?php print($i18n->interpolate("[[base-ipsec.removeProfileConfirm]]"))?>";
  message = top.code.string_substitute(message, "[[VAR.profileName]]", displayName);
 
  if(confirm(message))
    location = "/base/ipsec/profileDelete.php?profileName="+sendName;
}
</SCRIPT>
<?php print($scrollList->toHtml()); ?>
<BR>
<?php print($back->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>                                       
